/* 
 *  Licensed Materials - Property of IBM 
 *  Component IBM Rational ROSE_RT BUILD : TARGET_RTS 
 *  (c) Copyright IBM Corporation 1991, 2005 All Rights Reserved. 
 */

#ifndef __RTLog_h__
#define __RTLog_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTProtocol_h__
#include <RTProtocol.h>
#endif

class  RTDataObject;
struct RTObject_class;
class  RTString;
struct RTTypedValue;

struct Log
{
    class Base : public RTProtocol
    {
    private:
	// this will eventually be a file descriptor.
	int             file;

    public:
	RTS_INLINE      Base( void );
	RTS_INLINE      ~Base( void );

	static const RTProtocolDescriptor rt_class;

	RTS_INLINE void cr( void );
	void            crtab( int = 1 );
	void            open( const char * );
	void            open( void );
	void            close( void );

	void            log( const char * );
	void            log( const RTString & );

	void            show( const char * );
	void            show( const RTString & );

#if OBJECT_ENCODE
	void            log( char );
#if RTUseFloatingPoint
	void            log( double );
	void            log( float );
#endif
	void            log( int );
	void            log( long );
	void            log( short );
	void            log( const RTDataObject & );
	void            log( const void *, const RTObject_class * );
	RTS_INLINE void log( const RTTypedValue & );
	void            log( unsigned int );
	void            log( unsigned long );
	void            log( unsigned short );
	void            log( unsigned char );

	void            show( char );
#if RTUseFloatingPoint
	void            show( double );
	void            show( float );
#endif
	void            show( int );
	void            show( long );
	void            show( short );
	void            show( const RTDataObject & );
	void            show( const void *, const RTObject_class * );
	RTS_INLINE void show( const RTTypedValue & );
	void            show( unsigned int );
	void            show( unsigned long );
	void            show( unsigned short );
	void            show( unsigned char );
#endif

	void            space( void );
	void            tab( void );
	void            clear( void );
	void            commit( void );

    private:
	// unavailable methods
	Base( const Base & );
	Base & operator=( const Base & );
    };
};

#if RTS_INLINES
#include <RTLog.inl>
#endif

#endif // __RTLog_h__
