/* 
 *  Licensed Materials - Property of IBM 
 *  Component IBM Rational ROSE_RT BUILD : TARGET_RTS 
 *  (c) Copyright IBM Corporation 1991, 2005 All Rights Reserved. 
 */

// This file lists all the elements of  the  run-time  system.   The
// elements  are  organized  into groups according to the library to
// which they belong.  Groups are introduced by a GROUP  line.   The
// group  names  a  make variable which will include the name of the
// object file for that group.
//
// Within each group there is one entry per line. Each entry has two
// or  more  fields  separated  by  whitespace. The first field is a
// directory name; the second  is  the  base  name  of  a  file.  By
// convention  the directory name and file name typically correspond
// to the class name and member name, respectively.  The  third  and
// subsequent fields, if present, give an expression which evaluates
// to zero when the  element  should  be  excluded.  Note  that  the
// expression  is  evaluated by perl and so should be of a form that
// it can handle.

// A C++ preprocessor is used to make configuration information from
// RTConfig.h available here.

#include <RTConfig.h>

#ifndef PRAGMA
#define PRAGMA 0
#endif

// Build.pl ignores everything before the first GROUP line.

GROUP M // built directly in the lib directory

MAIN                  main

GROUP A // elements of primary object library

    RTAbortController    ct
    RTAbortController    dt
    RTAbortController    mainLoop
    RTAbortController    unused
    RTActiveConnector    ct
    RTActiveConnector    dt
    RTActiveConnector    enumerate
    RTActiveConnector    registerSAP
    RTActiveConnector    registerSPP
    RTActiveConnector    unused
    RTActor              badMessage
    RTActor              badState
    RTActor              component
    RTActor              control
    RTActor              ct
    RTActor              defaultClass
    RTActor              defaultController
    RTActor              designLevel
    RTActor              dt
    RTActor              enterState
    RTActor              enterStateV
    RTActor              exitState
    RTActor              exitStateV
    RTActor              exitToChainState
    RTActor              followIn
    RTActor              followInV
    RTActor              followOut
    RTActor              followOutV
    RTActor              getCurrentStateString
    RTActor              getName
    RTActor              getNumStates
    RTActor              getStateString
    RTActor              incarnateAllFixed
    RTActor              initMe_void
    RTActor              initializeAll
    RTActor              inlines              ! RTS_INLINES
    RTActor              isReferencedBy
    RTActor              isType
    RTActor              logMsg               LOG_MESSAGE
    RTActor              numComponents
    RTActor              predestroy
    RTActor              preinitialize
    RTActor              processHistory
    RTActor              removeAllImports
    RTActor              removeImport
    RTActor              suspend              SUSPEND
    RTActor              unbind
    RTActor              unused
    RTActorClass         EmptyActorClass
    RTActorClass         isKindOf
    RTActorClass         substitutableFor
    RTActorId            RTActor
    RTActorId            as_RTActor
    RTActorId            as_RTActorId
    RTActorId            ct
    RTActorId            dt
    RTActorId            eq_RTActorId
    RTActorId            eq_RTActorRef
    RTActorId            eq_RTDataObject
    RTActorId            getClassData
    RTActorId            getRTActor
    RTActorId            inlines              ! RTS_INLINES
    RTActorId            isValid
    RTActorId            resetActor
    RTActorId            rf
    RTActorRef           access
    RTActorRef           add
    RTActorRef           bind_ports
    RTActorRef           deport
    RTActorRef           deport_RTActor
    RTActorRef           deport_one
    RTActorRef           destroy
    RTActorRef           destroy_RTActor
    RTActorRef           dt
    RTActorRef           followIn
    RTActorRef           followOut
    RTActorRef           import
    RTActorRef           incarnate2
    RTActorRef           incarnateAll
    RTActorRef           incarnate_void
    RTActorRef           indexOf
    RTActorRef           init
    RTActorRef           initializeAll
    RTActorRef           inlines              ! RTS_INLINES
    RTActorRef           remove
    RTActorRef           reserve
    RTActorRef           unreserve
    RTActorRef           unused
    RTActor_class        findAttribute
    RTConnector          classData
    RTConnector          ct
    RTConnector          dt
    RTConnector          registerSAP
    RTConnector          registerSPP
    RTConnector          sap_ct
    RTConnector          sap_deregister
    RTConnector          sap_dt
    RTConnector          sap_getName
    RTConnector          sap_resize
    RTConnector          spp_ct
    RTConnector          spp_deregister
    RTConnector          spp_dt
    RTConnector          spp_getName
    RTConnector          spp_resize
    RTConnector          unused
    RTController         abort
    RTController         awaitResponse
    RTController         canPlugIn
    RTController         countActorDestroy    RTS_COUNT
    RTController         countActorIncarnate  RTS_COUNT
    RTController         countMessageTransfer RTS_COUNT
    RTController         countPortDestroy     RTS_COUNT
    RTController         countPortIncarnate   RTS_COUNT
    RTController         countTimerCancel     RTS_COUNT
    RTController         countTimerExpire     RTS_COUNT
    RTController         countTimerStart      RTS_COUNT
    RTController         ct
    RTController         destroy
    RTController         dispatch
    RTController         dt
    RTController         filterMessages
    RTController         freeTimerNode
    RTController         inlines              ! RTS_INLINES
    RTController         kill
    RTController         name
    RTController         newTimerNode
    RTController         perror
    RTController         printStats
    RTController         requeueMsg
    RTController         resourceMgr
    RTController         send
    RTController         strerror
    RTController         unused
    RTCounts             ct                   RTS_COUNT
    RTCounts             dt                   RTS_COUNT
    RTCounts             unused               RTS_COUNT
    RTElasticArray       as
    RTElasticArray       compact
    RTElasticArray       ct
    RTElasticArray       dt
    RTElasticArray       inlines              ! RTS_INLINES
    RTElasticArray       resize
    RTElasticArray       unusedIndex
    RTException          descriptor
    RTException          dt                   PRAGMA
    RTException          inlines              ! RTS_INLINES
    RTException          unused
    RTExceptionSignal    dt                   PRAGMA
    RTExceptionSignal    inlines              ! RTS_INLINES
    RTFrame              classIsKindOf
    RTFrame              className
    RTFrame              classOf
    RTFrame              deport
    RTFrame              descriptor
    RTFrame              destroy_RTActorId
    RTFrame              destroy_RTActorRef
    RTFrame              dt                   PRAGMA
    RTFrame              import_RTActorId
    RTFrame              import_RTActorRef
    RTFrame              incarnate1
    RTFrame              incarnate2
    RTFrame              incarnate4d
    RTFrame              incarnate4t
    RTFrame              incarnate5d
    RTFrame              incarnate5t
    RTFrame              incarnate5v
    RTFrame              incarnate6
    RTFrame              incarnationAt
    RTFrame              incarnationsOf
    RTFrame              inlines              ! RTS_INLINES
    RTFrame              me
    RTFrame              myClass
    RTFrame              permissionCheck  RTFRAME_CHECKING != RTFRAME_CHECK_NONE
    RTFrame              unused
    RTGlobalSignal       dt                   PRAGMA
    RTGlobalSignal       inlines              ! RTS_INLINES
    RTGlobalSignal       unknown
    RTInSignal           dt                   PRAGMA
    RTInSignal           inlines              ! RTS_INLINES
    RTJob                ct
    RTJob                dt
    RTJob                inlines              ! RTS_INLINES
    RTJob                unused
    RTLayerConnector     bind
    RTLayerConnector     buffer_as
    RTLayerConnector     buffer_ct
    RTLayerConnector     cleanup
    RTLayerConnector     connectors
    RTLayerConnector     ct
    RTLayerConnector     defaultService
    RTLayerConnector     dt
    RTLayerConnector     inlines              ! RTS_INLINES
    RTLayerConnector     install
    RTLayerConnector     lock
    RTLayerConnector     parseName
    RTLayerConnector     parseService
    RTLayerConnector     pendingSAPs
    RTLayerConnector     pendingSPPs
    RTLayerConnector     pending_ct
    RTLayerConnector     pending_deregister
    RTLayerConnector     pending_dt
    RTLayerConnector     pending_name
    RTLayerConnector     pending_resize
    RTLayerConnector     pending_size
    RTLayerConnector     registerSAP
    RTLayerConnector     registerSPP
    RTLayerConnector     showSAPs
    RTLayerConnector     total_replication
    RTLayerConnector     unbind
    RTLayerConnector     uninstall
    RTLayerConnector     unused
    RTLayerData          dt
    RTLayerData          inlines              ! RTS_INLINES
    RTLocalConnector     ct
    RTLocalConnector     dt
    RTLocalConnector     enumerate
    RTLocalConnector     registerSAP
    RTLocalConnector     registerSPP
    RTLocalConnector     request_ct
    RTLocalConnector     sap_ct
    RTLocalConnector     sap_deregister
    RTLocalConnector     sap_dt
    RTLocalConnector     sap_name
    RTLocalConnector     sap_resize
    RTLocalConnector     spp_append_request
    RTLocalConnector     spp_append_sap
    RTLocalConnector     spp_connectAll
    RTLocalConnector     spp_ct
    RTLocalConnector     spp_deregister
    RTLocalConnector     spp_dt
    RTLocalConnector     spp_name
    RTLocalConnector     spp_publish
    RTLocalConnector     spp_remove_request
    RTLocalConnector     spp_remove_sap
    RTLocalConnector     spp_resize
    RTLocalConnector     spp_sapTotal
    RTLocalConnector     spp_sppTotal
    RTLocalConnector     unused
    RTLog                clear
    RTLog                close
    RTLog                commit
    RTLog                crtab
    RTLog                descriptor
    RTLog                dt                  PRAGMA
    RTLog                inlines             ! RTS_INLINES
    RTLog                log_RTDataObject    OBJECT_ENCODE
    RTLog                log_RTString
    RTLog                log_char            OBJECT_ENCODE
    RTLog                log_double          OBJECT_ENCODE && RTUseFloatingPoint
    RTLog                log_float           OBJECT_ENCODE && RTUseFloatingPoint
    RTLog                log_int             OBJECT_ENCODE
    RTLog                log_unsignedint     OBJECT_ENCODE
	RTLog                log_unsignedlong    OBJECT_ENCODE
	RTLog                log_unsignedshort   OBJECT_ENCODE
	RTLog                log_unsignedchar	 OBJECT_ENCODE
    RTLog                log_long            OBJECT_ENCODE
    RTLog                log_short           OBJECT_ENCODE
    RTLog                log_string
    RTLog                log_type            OBJECT_ENCODE
    RTLog                open
    RTLog                open_char
    RTLog                show_RTDataObject   OBJECT_ENCODE
    RTLog                show_RTString
    RTLog                show_char           OBJECT_ENCODE
    RTLog                show_double         OBJECT_ENCODE && RTUseFloatingPoint
    RTLog                show_float          OBJECT_ENCODE && RTUseFloatingPoint
    RTLog                show_int            OBJECT_ENCODE
    RTLog                show_long           OBJECT_ENCODE
    RTLog                show_short          OBJECT_ENCODE
    RTLog                show_unsignedint    OBJECT_ENCODE
	RTLog                show_unsignedlong   OBJECT_ENCODE
	RTLog                show_unsignedshort  OBJECT_ENCODE
	RTLog                show_unsignedchar   OBJECT_ENCODE
    RTLog                show_string
    RTLog                show_type           OBJECT_ENCODE
    RTLog                space
    RTLog                tab
    RTLog                unused
    RTLogBuffer          ct
    RTLogBuffer          dt
    RTLogBuffer          flush
    RTLogBuffer          unused
    RTMain               controller
    RTMain               debugName
    RTMain               execute
    RTMain               inlines              ! RTS_INLINES
    RTMain               installHandlers
    RTMain               installOneHandler
    RTMain               mainLine
    RTMain               removeHandlers
    RTMain               removeOneHandler
    RTMain               shutdown
    RTMain               superActor
    RTMain               system
    RTMain               targetShutdown
    RTMain               targetStartup
    RTMain               topReference
    RTMessage            as
    RTMessage            ct
    RTMessage            defer
    RTMessage            deliver
    RTMessage            dt                   PRAGMA
    RTMessage            getGlobalSignal      RTRUNTIMEBC
    RTMessage            getSignalName
    RTMessage            inlines              ! RTS_INLINES
    RTMessage            internData
    RTMessage            reply                RTRUNTIMEBC
    RTMessageQ           ct
    RTMessageQ           dt
    RTMessageQ           filterAll
    RTMessageQ           filterOne
    RTMessageQ           inlines              ! RTS_INLINES
    RTMessageQ           link
    RTMessageQ           nqHead
    RTMessageQ           size
    RTMessageQ           unused
    RTOutSignal          dt                   PRAGMA
    RTOutSignal          inlines              ! RTS_INLINES
    RTPrefix             inlines              ! RTS_INLINES
    RTProtocol           bindAt
    RTProtocol           bindingNotification
    RTProtocol           context
    RTProtocol           defaultLayerName
    RTProtocol           deregister
    RTProtocol           deregisterSAP
    RTProtocol           deregisterSPP
    RTProtocol           dt
    RTProtocol           getGlobalSignal      RTRUNTIMEBC
    RTProtocol           getInfo
    RTProtocol           getLocalSignal       RTRUNTIMEBC
    RTProtocol           getRegisteredName
    RTProtocol           indexTo
    RTProtocol           init
    RTProtocol           inlines              ! RTS_INLINES
    RTProtocol           invoke
    RTProtocol           invokeAt
    RTProtocol           invokeOne
    RTProtocol           isBoundAt
    RTProtocol           isIndexTo
    RTProtocol           notifyBoundAt
    RTProtocol           notifyInit
    RTProtocol           peerAt
    RTProtocol           purge
    RTProtocol           purgeAt
    RTProtocol           purgeSignal
    RTProtocol           purgeSignalAt
    RTProtocol           raise
    RTProtocol           recall
    RTProtocol           recallAll
    RTProtocol           recallAllAt
    RTProtocol           recallAllFront
    RTProtocol           recallAt
    RTProtocol           recallFront
    RTProtocol           recallSignal
    RTProtocol           recallSignalAll
    RTProtocol           recallSignalAllAt
    RTProtocol           recallSignalAt
    RTProtocol           receiveCheck
    RTProtocol           receiveTypeCheckEnable
    RTProtocol           registerAs           RTS_COMPATIBLE <= 520
    RTProtocol           registerSAP
    RTProtocol           registerSPP
    RTProtocol           reply
    RTProtocol           resetFlag
    RTProtocol           resize
    RTProtocol           send
    RTProtocol           sendAt
    RTProtocol           sendCheck
    RTProtocol           sendOne
    RTProtocol           sendTypeCheckEnable
    RTProtocol           setFlag
    RTProtocol           unbindAt
    RTProtocol           unused
    RTProtocolAdapter    adapt
    RTProtocolAdapter    ct
    RTProtocolAdapter    dt
    RTProtocolDescriptor canReceive
    RTProtocolDescriptor compare
    RTProtocolDescriptor getUnknownGlobalSignal RTRUNTIMEBC
    RTProtocolDescriptor getUnknownLocalSignal  RTRUNTIMEBC
    RTProtocolDescriptor inSignalName
    RTProtocolDescriptor inSignalNamed
    RTProtocolDescriptor inlines              ! RTS_INLINES
    RTPurgeFilter        accept
    RTPurgeFilter        ct
    RTPurgeFilter        dt
    RTPurgeFilter        select
    RTPurgeFilter        unused
    RTQFilter            dt
    RTQFilter            inlines              ! RTS_INLINES
    RTQFilter            unused
    RTQueue              add
    RTQueue              as
    RTQueue              ct
    RTQueue              dt
    RTQueue              inlines              ! RTS_INLINES
    RTQueue              length
    RTQueue              next
    RTQueue              remove
    RTRecallFilter       accept
    RTRecallFilter       ct
    RTRecallFilter       dt
    RTRecallFilter       select
    RTRecallFilter       unused
    RTRelayPort          directUse
    RTRelayPort          dt
    RTRelayPort          followIn
    RTRelayPort          followOut
    RTRelayPort          init
    RTRelayPort          inlines              ! RTS_INLINES
    RTRelayPort          reserve
    RTRelayPort          unreserve
    RTRelayPort          unused
    RTResourceMgr        ct
    RTResourceMgr        dt
    RTResourceMgr        msgAlloc
    RTResourceMgr        msgFree
    RTResourceMgr        unused
    RTRootProtocol       descriptor
    RTRootProtocol       dt                   PRAGMA
    RTRootProtocol       inlines              ! RTS_INLINES
    RTSuperActor         ct
    RTSuperActor         dt
    RTSuperActor         getActorData
    RTSuperActor         initialize
    RTSuperActor         rtsBehavior
    RTSuperActor         start
    RTSuperActor         unused
    RTSymmetricSignal    dt                   PRAGMA
    RTSymmetricSignal    inlines              ! RTS_INLINES
    RTTimerActor         adjustTimeBegin
    RTTimerActor         adjustTimeEnd
    RTTimerActor         cancel
    RTTimerActor         cancelAll
    RTTimerActor         ct
    RTTimerActor         designLevel
    RTTimerActor         dt
    RTTimerActor         getActorData
    RTTimerActor         getRelativeClock
    RTTimerActor         informAgain
    RTTimerActor         informAt
    RTTimerActor         informIn
    RTTimerActor         inlines              ! RTS_INLINES
    RTTimerActor         nextTimeout
    RTTimerActor         numPending
    RTTimerActor         rtsBehavior
    RTTimerActor         sendTimeouts
    RTTimerActor         soleInstance
    RTTimerActor         start
    RTTimerActor         stop
    RTTimerActor         unused
    RTTimerId            as
    RTTimerId            classData
    RTTimerId            dt
    RTTimerId            inlines              ! RTS_INLINES
    RTTimerId            timeouts
    RTTimerList          cancelAll
    RTTimerList          ct
    RTTimerList          dt
    RTTimerList          expire
    RTTimerList          headTime
    RTTimerList          inlines              ! RTS_INLINES
    RTTimerList          insert
    RTTimerList          remove
    RTTimerList          unused
    RTTimerNode          buildMsg
    RTTimerNode          cancel
    RTTimerNode          clear
    RTTimerNode          connect
    RTTimerNode          ct
    RTTimerNode          deliver
    RTTimerNode          disconnect
    RTTimerNode          disconnectAll
    RTTimerNode          dt
    RTTimerNode          setValue
    RTTimerNode          timeout
    RTTimerNode          unused
    RTTiming             adjustTimeBegin
    RTTiming             adjustTimeEnd
    RTTiming             cancelTimer
    RTTiming             currentTime
    RTTiming             descriptor
    RTTiming             dt                   PRAGMA
    RTTiming             informAt
    RTTiming             informIn
    RTTiming             informIn0            RTS_COMPATIBLE <= 640
    RTTiming             inlines              ! RTS_INLINES
    RTTiming             timeouts
    RTTiming             unused

#if USE_THREADS
    RTActorRef           lock
    RTController         acceptIncoming
    RTController         peer_receive
    RTController         wakeup
    RTCustomController   ct
    RTCustomController   dt
    RTCustomController   mainLoop
    RTCustomController   registerLayer
    RTCustomController   unused
    RTCustomController   waitForEvents
    RTCustomController   wakeup
    RTExternal           descriptor
    RTExternal           disable
    RTExternal           dt
    RTExternal           enable
    RTExternal           inlines              ! RTS_INLINES
    RTExternal           raise
    RTExternal           unload
    RTExternal           unused
    RTPeerController     ct
    RTPeerController     dt
    RTPeerController     mainLoop
    RTPeerController     shutdown
    RTPeerController     startup
    RTPeerController     unused
    RTPeerController     waitForEvents
    RTSyncObject         ct
    RTSyncObject         dt
    RTSyncObject         signal
    RTSyncObject         timedwait
    RTSyncObject         wait
    RTThread             ct
    RTThread             dt
    RTThread             unused
    RTTimerController    ct
    RTTimerController    dt
    RTTimerController    mainLoop
    RTTimerController    printStats
    RTTimerController    unused
    RTTimerController    waitForEvents
#endif // USE_THREADS

#if ! USE_THREADS
    RTSoleController     ct
    RTSoleController     dt
    RTSoleController     mainLoop
    RTSoleController     printStats
    RTSoleController     timer_interrupt
    RTSoleController     unused
    RTSoleController     waitForEvents
#endif // ! USE_THREADS

#if OBSERVABLE
    RTActor              rtgChainBegin
    RTActor              rtgTransitionBegin
    RTActor              rtgTransitionEnd
    RTActorProbe         accessFieldValue
    RTActorProbe         addFieldValue
    RTActorProbe         connectProbe
    RTActorProbe         context
    RTActorProbe         ct
    RTActorProbe         disconnectProbe
    RTActorProbe         dt
    RTActorProbe         evtChain
    RTActorProbe         evtHistory
    RTActorProbe         evtMessageIn
    RTActorProbe         evtMessageOut
    RTActorProbe         evtMessageOutIn
    RTActorProbe         evtPresence
    RTActorProbe         evtReference
    RTActorProbe         getActorFromStrPath
    RTActorProbe         getTypeStr
    RTActorProbe         inject
    RTActorProbe         setChain
    RTActorProbe         unused
    RTActorRefProbe      connectProbe
    RTActorRefProbe      ct
    RTActorRefProbe      disconnectProbe
    RTActorRefProbe      dt
    RTActorRefProbe      evtPresence
    RTActorRefProbe      evtReference
    RTActorRefProbe      getRefFromStrPath
    RTActorRefProbe      inlines              ! RTS_INLINES
    RTActorRefProbe      unused
    RTCmdLineObserver    ct
    RTCmdLineObserver    dt
    RTCmdLineObserver    evtRtsStatus
    RTCmdLineObserver    receiveData
    RTCmdLineObserver    unused
    RTController         breakPoint
    RTDaemon             addInfo
    RTDaemon             ct
    RTDaemon             delInfo
    RTDaemon             dt
    RTDaemon             eventMatches
    RTDaemon             fieldValue
    RTDaemon             inject
    RTDaemon             inlines              ! RTS_INLINES
    RTDaemon             posInfo
    RTDaemon             refresh
    RTDaemon             setInfo
    RTDaemon             setting
    RTDaemon             unused
    RTDaemon             updateSettings
    RTDaemonInfo         ct
    RTDaemonInfo         dt
    RTDaemonInfo         setInfo
    RTDaemonInfo         setInfoActor
    RTDaemonInfo         setInfoChain
    RTDaemonInfo         setInfoPort
    RTDaemonInfo         setInfoState
    RTDaemonInfo         setInfoVariable
    RTDaemonInfo         unused
    RTDebugger           actorDestroyed
    RTDebugger           actorIncarnated
    RTDebugger           addEvent
    RTDebugger           addFieldValue
    RTDebugger           addProbe
    RTDebugger           breakPoint
    RTDebugger           checkObservability
    RTDebugger           closeObservability
    RTDebugger           deleteProbe
    RTDebugger           dispatchEvent
    RTDebugger           doInject
    RTDebugger           evtHistory
    RTDebugger           evtPresence
    RTDebugger           evtReference
    RTDebugger           evtRtsStatus
    RTDebugger           evtVariable
    RTDebugger           findObserver
    RTDebugger           getHistory
    RTDebugger           getPresence
    RTDebugger           getProbe
    RTDebugger           getReference
    RTDebugger           getTimestamp
    RTDebugger           inject
    RTDebugger           mainObserverLoop
    RTDebugger           newConnection
    RTDebugger           probeAttention
    RTDebugger           probeCreated
    RTDebugger           sendProbeSignal
    RTDebugger           setTimestamp
    RTDebugger           shutdownUdp          USE_THREADS
    RTDebugger           startupUdp           USE_THREADS
    RTDebugger           useEvent
    RTDebugger           wakeupUdp            USE_THREADS
    RTEventInfo          ct
    RTEventInfo          dt
    RTEventInfo          unused
    RTObserver           addInfo
    RTObserver           cmdCommand
    RTObserver           cmdCreateDaemon
    RTObserver           cmdDestroyDaemon
    RTObserver           ct
    RTObserver           delInfo
    RTObserver           dispatchEvent
    RTObserver           dt
    RTObserver           evtChain
    RTObserver           evtHistory
    RTObserver           evtMessageIn
    RTObserver           evtMessageOut
    RTObserver           evtMessageOutIn
    RTObserver           evtPresence
    RTObserver           evtReference
    RTObserver           evtRtsStatus
    RTObserver           evtVariable
    RTObserver           prepareEvent
    RTObserver           readData
    RTObserver           receiveData
    RTObserver           sendData
    RTObserver           setDaemon
    RTObserver           transmitData
    RTObserver           unused
    RTToolsetObserver    accessVariable
    RTToolsetObserver    buildString
    RTToolsetObserver    ct
    RTToolsetObserver    dt
    RTToolsetObserver    encoDeco
    RTToolsetObserver    endeBoth
    RTToolsetObserver    endeTarg
    RTToolsetObserver    evtChain
    RTToolsetObserver    evtHistory
    RTToolsetObserver    evtMessageIn
    RTToolsetObserver    evtMessageOut
    RTToolsetObserver    evtMessageOutIn
    RTToolsetObserver    evtPresence
    RTToolsetObserver    evtReference
    RTToolsetObserver    evtRtsStatus
    RTToolsetObserver    evtVariable
    RTToolsetObserver    handleActor
    RTToolsetObserver    handleChain
    RTToolsetObserver    handleDaemon
    RTToolsetObserver    handleInject
    RTToolsetObserver    handlePort
    RTToolsetObserver    handleState
    RTToolsetObserver    handleVariable
    RTToolsetObserver    receiveData
    RTToolsetObserver    sendResultCode
    RTToolsetObserver    sendTxBuffer
    RTToolsetObserver    transmitData
    RTToolsetObserver    unused
    RTWebObserver        ct
    RTWebObserver        dt
    RTWebObserver        receiveData
    RTWebObserver        unused
#endif // OBSERVABLE

#if OTRTSDEBUG != DEBUG_NONE
    RTController         setError
    RTController         trace                OTRTSDEBUG >= DEBUG_VERBOSE
    RTDebugger           attach
    RTDebugger           ct
    RTDebugger           debugIt
    RTDebugger           deregisterRTS
    RTDebugger           detach
    RTDebugger           doCmd
    RTDebugger           doCmdExit
    RTDebugger           doCmdQuit
    RTDebugger           doCmdSystem
    RTDebugger           dt
    RTDebugger           findActor
    RTDebugger           freeMsg
    RTDebugger           getActor
    RTDebugger           getCategory
    RTDebugger           getCommand
    RTDebugger           getLevel
    RTDebugger           getTask
    RTDebugger           inlines              ! RTS_INLINES
    RTDebugger           kill
    RTDebugger           logMessage
    RTDebugger           mainLoop
    RTDebugger           name
    RTDebugger           newMsg
    RTDebugger           printActor
    RTDebugger           printActorInfo
    RTDebugger           printHelp
    RTDebugger           printMessage
    RTDebugger           printPort
    RTDebugger           printRef
    RTDebugger           printStructure
    RTDebugger           proceed
    RTDebugger           registerRTS
    RTDebugger           step
    RTDebugger           step_begin
    RTDebugger           step_end
    RTDebugger           trace
    RTDebugger           unused
    RTDebugger           wakeup               USE_THREADS
    RTDebuggerInput      ct
    RTDebuggerInput      dt
    RTDebuggerInput      getChar
    RTDebuggerInput      getCommand
    RTDebuggerInput      getEol
    RTDebuggerInput      getNumber
    RTDebuggerInput      getString
    RTDebuggerInput      inlines              ! RTS_INLINES
    RTDebuggerInput      nextChar
    RTDebuggerInput      pushInput
    RTDebuggerInput      setPrompt
    RTDebuggerInput      ungetChar
    RTDebuggerInput      unused
    RTMain               debugPriority        USE_THREADS
    RTMain               debugStackSize       USE_THREADS
    RTProbe              breakPointAction
    RTProbe              connectProbe
    RTProbe              ct
    RTProbe              disconnectProbe
    RTProbe              dt
    RTProbe              inlines              ! RTS_INLINES
    RTProbe              unused
#endif // OTRTSDEBUG != DEBUG_NONE

GROUP D // elements of secondary object library

    RTArray_class        ct
    RTBoolean            RTFalse
    RTBoolean            RTTrue
    RTBoolean            as
    RTBoolean            ct
    RTBoolean            dt
    RTBoolean            getClassData
    RTBoolean            inlines              ! RTS_INLINES
    RTByteBlock          as
    RTByteBlock          ct
    RTByteBlock          dt
    RTByteBlock          eq
    RTByteBlock          getClassData
    RTByteBlock          inlines              ! RTS_INLINES
    RTCachedString       add
    RTCachedString       as
    RTCachedString       ct
    RTCachedString       dt
    RTCachedString       inlines              ! RTS_INLINES
    RTCachedString       link
    RTCachedString       lock
    RTCachedString       unlink
    RTCharacter          as
    RTCharacter          asciiValue
    RTCharacter          char
    RTCharacter          ct
    RTCharacter          dt
    RTCharacter          eq
    RTCharacter          getClassData
    RTCharacter          inlines              ! RTS_INLINES
    RTCharacter          isAlphabetic
    RTCharacter          isDigit
    RTCharacter          isLowerCase
    RTCharacter          isSeparator
    RTCharacter          isUpperCase
    RTDataObject         EmptyObject
    RTDataObject         copy
    RTDataObject         ct
    RTDataObject         destroy
    RTDataObject         dt
    RTDataObject         eq
    RTDataObject         getClassData
    RTDataObject         getTypeName
    RTDataObject         getVersion
    RTDataObject         inlines              ! RTS_INLINES
    RTDataObject         isSameType
    RTDataObject         isType
    RTDataObject         pRTDataObject
    RTDiag               assert
    RTDiag               out
    RTDiag               panic
    RTDiagBuffer         ct
    RTDiagBuffer         dt
    RTDiagBuffer         flush
    RTDiagBuffer         unused
    RTDiagStream         ct
    RTDiagStream         dt
    RTDiagStream         flush
    RTDiagStream         inlines              ! RTS_INLINES
    RTDiagStream         ls_long
    RTDiagStream         ls_strings
    RTDiagStream         ls_unsigned
    RTDiagStream         ls_void
    RTDiagStream         write
    RTDictionary         as
    RTDictionary         atPut
    RTDictionary         ct
    RTDictionary         dt
    RTDictionary         find
    RTDictionary         hash
    RTDictionary         inlines              ! RTS_INLINES
    RTDictionary         iterate
    RTDictionary         remove
    RTDictionary         vc
    RTEnumerated         as
    RTEnumerated         classData
    RTEnumerated         ct
    RTEnumerated         dt
    RTEnumerated         eq
    RTEnumerated         inlines              ! RTS_INLINES
    RTEnumerated         lower
    RTEnumerated         upper
    RTFieldDescriptor    constant
    RTFieldDescriptor    copy
    RTFieldDescriptor    destroy
    RTFieldDescriptor    init
    RTFieldDescriptor    lookup
    RTFloat              assign               RTUseFloatingPoint
    RTFloat              clear                RTUseFloatingPoint
    RTFloat              div10                RTUseFloatingPoint
    RTFloat              mod10                RTUseFloatingPoint
    RTFloat              mul10                RTUseFloatingPoint
    RTFloat              multiply             RTUseFloatingPoint
    RTFloat              normalize            RTUseFloatingPoint
    RTFloat              pow2                 RTUseFloatingPoint
    RTFloat              value                RTUseFloatingPoint
    RTFormat             double               RTUseFloatingPoint
    RTFormat             float                RTUseFloatingPoint
    RTFormat             int
    RTFormat             long
    RTFormat             unsigned
    RTFormat             void
    RTIBuffer            ct
    RTIBuffer            dt
    RTIBuffer            unused
    RTInteger            DefaultDelay
    RTInteger            EmptyInteger
    RTInteger            as_RTInteger
    RTInteger            as_int
    RTInteger            ct
    RTInteger            dt
    RTInteger            eq
    RTInteger            getClassData
    RTInteger            inlines              ! RTS_INLINES
    RTInterval           ami
    RTInterval           apl
    RTInterval           as
    RTInterval           classData
    RTInterval           ct
    RTInterval           dt                   PRAGMA
    RTInterval           ge0
    RTInterval           gt0
    RTInterval           inlines              ! RTS_INLINES
    RTInterval           is0
    RTInterval           isset
    RTInterval           le0
    RTInterval           lt
    RTInterval           mi
    RTInterval           pl
    RTInterval           ticks
    RTMain               argc
    RTMain               argv
    RTMemoryInBuffer     ct
    RTMemoryInBuffer     dt
    RTMemoryInBuffer     get
    RTMemoryInBuffer     unused
    RTMemoryOutBuffer    ct
    RTMemoryOutBuffer    dt
    RTMemoryOutBuffer    flush
    RTMemoryOutBuffer    unused
    RTMemoryOutBuffer    write
    RTMemoryUtil         atoi
    RTMemoryUtil         getenv
    RTMemoryUtil         memcmp
    RTMemoryUtil         memcpy
    RTMemoryUtil         memdup
    RTMemoryUtil         memset
    RTMemoryUtil         strchr
    RTMemoryUtil         strcmp
    RTMemoryUtil         strcpy
    RTMemoryUtil         strdup
    RTMemoryUtil         strlen
    RTOBuffer            ct
    RTOBuffer            dt
    RTOBuffer            unused
    RTObject_class       abstract
    RTObject_class       allocate
    RTObject_class       array_copy
    RTObject_class       array_destroy
    RTObject_class       array_init
    RTObject_class       bool
    RTObject_class       char
    RTObject_class       destroy
    RTObject_class       double               RTUseFloatingPoint
    RTObject_class       float                RTUseFloatingPoint
    RTObject_class       inlines              ! RTS_INLINES
    RTObject_class       install
    RTObject_class       int
	RTObject_class       unsignedint
	RTObject_class       unsignedlong
	RTObject_class       unsignedshort
	RTObject_class       unsignedchar
    RTObject_class       isKindOf
    RTObject_class       long
    RTObject_class       nop
    RTObject_class       pvoid
    RTObject_class       short
    RTObject_class       string
    RTObject_class       struct_copy
    RTObject_class       struct_destroy
    RTObject_class       struct_init
    RTObject_class       uchar
    RTObject_class       ulong
    RTObject_class       unsigned
    RTObject_class       ushort
    RTObject_class       void
    RTPointer            as
    RTPointer            ct
    RTPointer            dt
    RTPointer            eq
    RTPointer            getClassData
    RTPointer            inlines              ! RTS_INLINES
    RTPriority           ct
    RTPriority           dt
    RTPriority           getClassData
    RTPriority           inlines              ! RTS_INLINES
    RTPriority           lookup
    RTPriority           name
    RTSequence           as
    RTSequence           ct
    RTSequence           dt
    RTSequence           getClassData
    RTSequence           inlines              ! RTS_INLINES
    RTSequenceOf         as
    RTSequenceOf         ct
    RTSequenceOf         ct1
    RTSequenceOf         ct2
    RTSequenceOf         dt
    RTSequenceOf         eq
    RTSequenceOf         getClassData
    RTSequenceOf         inlines              ! RTS_INLINES
    RTSequenceOf         spaceClean
    RTSequenceOf         vc
    RTSignal             EmptySignal
    RTSignal             ct
    RTSignal             dt
    RTSignal             getClassData
    RTSignal             inlines              ! RTS_INLINES
    RTStreamBuffer       ct
    RTStreamBuffer       dt
    RTStreamBuffer       unused
    RTStreamBuffer       write
    RTString             as
    RTString             ct
    RTString             dt
    RTString             eq
    RTString             eq_string
    RTString             getClassData
    RTString             inlines              ! RTS_INLINES
    RTString             vc
    RTTime               ami
    RTTime               apl
    RTTime               as
    RTTime               asInt
    RTTime               asTime
    RTTime               ct
    RTTime               dt
    RTTime               eq
    RTTime               getClassData
    RTTime               inlines              ! RTS_INLINES
    RTTime               lt
    RTTime               mi
    RTTime               now
    RTTime               pl
    RTTimespec           ami
    RTTimespec           apl
    RTTimespec           classData
    RTTimespec           ct_interval
    RTTimespec           ct_time
    RTTimespec           dt                   PRAGMA
    RTTimespec           getclock
    RTTimespec           inlines              ! RTS_INLINES
    RTTimespec           mi
    RTTimespec           normalize
    RTTimespec           pl
    RTTimespec           ticksFromNow
    RTTimespec           zero
    RTTruncatingBuffer   ct
    RTTruncatingBuffer   dt
    RTTruncatingBuffer   unused
    RTTypedValue         bool
    RTTypedValue         char
    RTTypedValue         double               RTUseFloatingPoint
    RTTypedValue         float                RTUseFloatingPoint
    RTTypedValue         inlines              ! RTS_INLINES
    RTTypedValue         int
	RTTypedValue         unsignedint
	RTTypedValue         unsignedlong
	RTTypedValue         unsignedshort
	RTTypedValue         unsignedchar
    RTTypedValue         long
    RTTypedValue         pvoid
    RTTypedValue         short
    RTTypedValue         string
    RTWrapper            as
    RTWrapper            classData
    RTWrapper            ct
    RTWrapper            dt
    RTWrapper            inlines              ! RTS_INLINES

#if RTREAL_INCLUDED
    RTReal               as_RTReal
    RTReal               as_double
    RTReal               ct
    RTReal               double
    RTReal               dt
    RTReal               eq
    RTReal               float
    RTReal               getClassData
    RTReal               inlines              ! RTS_INLINES
#endif // RTREAL_INCLUDED

#if USE_THREADS
    RTMain               lock
    RTMutex              ct
    RTMutex              dt
    RTMutex              enter
    RTMutex              leave
#endif // USE_THREADS

#if HAVE_INET
    RTIOMonitor          add
    RTIOMonitor          anyRegistered
    RTIOMonitor          ct
    RTIOMonitor          dt
    RTIOMonitor          remove
    RTIOMonitor          status
    RTIOMonitor          unused
    RTIOMonitor          wait
    RTTcpInBuffer        ct
    RTTcpInBuffer        dt
    RTTcpInBuffer        get
    RTTcpInBuffer        unused
    RTTcpOutBuffer       ct
    RTTcpOutBuffer       dt
    RTTcpOutBuffer       flush
    RTTcpOutBuffer       unused
    RTTcpSocket          acceptFrom
    RTTcpSocket          close
    RTTcpSocket          connect
    RTTcpSocket          create
    RTTcpSocket          ct
    RTTcpSocket          dt
    RTTcpSocket          getLocalName
    RTTcpSocket          getLocalPort
    RTTcpSocket          getPrimary
    RTTcpSocket          hasData
    RTTcpSocket          listen
    RTTcpSocket          lookup
    RTTcpSocket          lookup_numeric
    RTTcpSocket          read
    RTTcpSocket          registerWith
    RTTcpSocket          state
    RTTcpSocket          try_connect
    RTTcpSocket          unused
    RTTcpSocket          write
    RTinet               accept
    RTinet               async
    RTinet               bind
    RTinet               close
    RTinet               connect
    RTinet               getname
    RTinet               listen
    RTinet               lookup
    RTinet               loopback
    RTinet               nonblocking
    RTinet               primary
    RTinet               read
    RTinet               recvfrom
    RTinet               reuseaddr
    RTinet               sendto
    RTinet               tcp
    RTinet               udp
    RTinet               write
#endif // HAVE_INET

#if OBJECT_DECODE
    RTAsciiDecoding      ct
    RTAsciiDecoding      dt
    RTAsciiDecoding      get
    RTAsciiDecoding      getByte
    RTAsciiDecoding      getError
    RTAsciiDecoding      getFieldListFinish
    RTAsciiDecoding      getFieldListStart
    RTAsciiDecoding      getFieldName
    RTAsciiDecoding      getFieldSeparator
    RTAsciiDecoding      getName
    RTAsciiDecoding      getNonWhite
    RTAsciiDecoding      getUnknown
    RTAsciiDecoding      get_address
    RTAsciiDecoding      get_array
    RTAsciiDecoding      get_bool
    RTAsciiDecoding      get_char
    RTAsciiDecoding      get_double           RTUseFloatingPoint
    RTAsciiDecoding      get_enum
    RTAsciiDecoding      get_float            RTUseFloatingPoint
    RTAsciiDecoding      get_indirect
    RTAsciiDecoding      get_int
    RTAsciiDecoding      get_long
#if 0
    RTAsciiDecoding      get_long_long
#endif
    RTAsciiDecoding      get_opaque
    RTAsciiDecoding      get_short
    RTAsciiDecoding      get_string
    RTAsciiDecoding      get_struct
    RTAsciiDecoding      get_uchar
    RTAsciiDecoding      get_ulong
    RTAsciiDecoding      get_unsigned
    RTAsciiDecoding      get_ushort
	RTAsciiDecoding      get_unsignedint
	RTAsciiDecoding      get_unsignedlong
	RTAsciiDecoding      get_unsignedshort
	RTAsciiDecoding      get_unsignedchar
    RTAsciiDecoding      ungetByte
    RTAsciiDecoding      unused
    RTDataObject         ObjectForm
    RTDecoding           ct
    RTDecoding           dt
    RTDecoding           unused
    RTEnumerated         decode
    RTFieldDescriptor    decode
    RTObject_class       array_decode
    RTObject_class       enum_decode
    RTObject_class       inherit_decode
    RTObject_class       installer_ct
    RTObject_class       installer_head
    RTObject_class       installer_installAll
    RTObject_class       installer_unused
    RTObject_class       struct_decode
    RTUnknownObject      classData
    RTVAsciiDecoding     ct
    RTVAsciiDecoding     dt
    RTVAsciiDecoding     get
    RTVAsciiDecoding     unused
#endif // OBJECT_DECODE

#if OBJECT_ENCODE
    RTAsciiEncoding      ct
    RTAsciiEncoding      dt
    RTAsciiEncoding      flush
    RTAsciiEncoding      getError
    RTAsciiEncoding      put
    RTAsciiEncoding      putCode
    RTAsciiEncoding      putFieldListFinish
    RTAsciiEncoding      putFieldListStart
    RTAsciiEncoding      putFieldSeparator
    RTAsciiEncoding      putFields
    RTAsciiEncoding      putName
    RTAsciiEncoding      putType
    RTAsciiEncoding      put_address
    RTAsciiEncoding      put_array
    RTAsciiEncoding      put_bool
    RTAsciiEncoding      put_char
    RTAsciiEncoding      put_double           RTUseFloatingPoint
    RTAsciiEncoding      put_enum
    RTAsciiEncoding      put_float            RTUseFloatingPoint
    RTAsciiEncoding      put_indirect
    RTAsciiEncoding      put_int
    RTAsciiEncoding      put_long
    RTAsciiEncoding      put_opaque
    RTAsciiEncoding      put_short
    RTAsciiEncoding      put_string
    RTAsciiEncoding      put_struct
    RTAsciiEncoding      put_uchar
    RTAsciiEncoding      put_ulong
    RTAsciiEncoding      put_unsigned
    RTAsciiEncoding      put_ushort
	RTAsciiEncoding		 put_unsignedint
	RTAsciiEncoding		 put_unsignedlong
	RTAsciiEncoding		 put_unsignedshort
	RTAsciiEncoding		 put_unsignedchar
    RTAsciiEncoding      unused
    RTDataObject         printString
    RTDataObject         printString2
    RTDataObject         put
    RTDiagStream         write_type
    RTEncoding           ct
    RTEncoding           dt
    RTEncoding           unused
    RTEnumerated         encode
    RTFieldDescriptor    encode
    RTObject_class       array_encode
    RTObject_class       enum_encode
    RTObject_class       inherit_encode
    RTObject_class       struct_encode
    RTVAsciiEncoding     ct
    RTVAsciiEncoding     dt
    RTVAsciiEncoding     putType
    RTVAsciiEncoding     unused
#endif // OBJECT_ENCODE

GROUP Z // not in any library

    RTSample             sample1
    RTSample             sample2
    RTSample             sample3

#include <TARGET-MANIFEST.cpp>
