/* 
 *  Licensed Materials - Property of IBM 
 *  Component IBM Rational ROSE_RT BUILD : TARGET_RTS 
 *  (c) Copyright IBM Corporation 1991, 2005 All Rights Reserved. 
 */

#include <RTAsciiDecoding.h>
#if _MSC_VER > 1000
int RTAsciiDecoding::get_long_long( __int64 & value )
#else
int RTAsciiDecoding::get_long_long( long long & value )
#endif
{
#if _MSC_VER > 1000
    const __int64 max_div_10 =              ( ~0UL >> 1 )   / 10UL;
    const __int64 max_mod_10 =              ( ~0UL >> 1 )   % 10UL;
    const __int64 min_div_10 = - (__int64)( ( ~( ~0UL >> 1 ) ) / 10UL );
    const __int64 min_mod_10 = - (__int64)( ( ~( ~0UL >> 1 ) ) % 10UL );
#else
    const long long max_div_10 =              ( ~0UL >> 1 )   / 10UL;
    const long long max_mod_10 =              ( ~0UL >> 1 )   % 10UL;
    const long long min_div_10 = - (long long )( ( ~( ~0UL >> 1 ) ) / 10UL );
    const long long min_mod_10 = - (long long )( ( ~( ~0UL >> 1 ) ) % 10UL );
#endif

    enum { someDigits = 1, overflow = 2 };

#if _MSC_VER > 1000
    __int64  tmp = 0L;
#else
    long long tmp    = 0L;
#endif
    int  status = 0;
    bool pos    = true;
    char byte;

    if( getNonWhite( byte ) == 0 )
	return 0;

    if( byte == '-' )
    {
	pos = false;
	if( getByte( byte ) == 0 )
	    return 0;
    }

    do
    {
	if( '0' <= byte && byte <= '9' )
	{
	    status |= someDigits;

	    long digit = (long)( byte - '0' );

	    if( pos )
	    {
		if( tmp < max_div_10 )
		{
		    // no possibility of overflow
		}
		else if( tmp > max_div_10 || digit > max_mod_10 )
		{
		    status |= overflow;
		}
	    }
	    else
	    {
		digit = - digit;

		if( tmp > min_div_10 )
		{
		    // no possibility of overflow
		}
		else if( tmp < min_div_10 || digit < min_mod_10 )
		{
		    status |= overflow;
		}
	    }

	    tmp *= 10L;
	    tmp += digit;
	}
	else
	{
	    ungetByte( byte );
	    break;
	}
    }
    while( getByte( byte ) != 0 );

    if( status != someDigits )
	return 0;

    value = tmp;

    return 1;
}
