/* 
 *  Licensed Materials - Property of IBM 
 *  Component IBM Rational ROSE_RT BUILD : TARGET_RTS 
 *  (c) Copyright IBM Corporation 1991, 2005 All Rights Reserved. 
 */

#include <RTAsciiDecoding.h>

int RTAsciiDecoding::get_unsignedlong( unsigned long & value )
{
    const unsigned long max_div_10 = ( ~0UL ) / 10UL;
    const unsigned long max_mod_10 = ( ~0UL ) % 10UL;

    enum { someDigits = 1, overflow = 2 };

    unsigned long tmp    = 0UL;
    int           status = 0;
    char          byte;

    if( getNonWhite( byte ) == 0 )
	return 0;

    do
    {
	if( '0' <= byte && byte <= '9' )
	{
	    unsigned long digit = (unsigned long)(int)( byte - '0' );

	    if( tmp < max_div_10 )
	    {
		// no possibility of overflow
	    }
	    else if( tmp > max_div_10 || digit > max_mod_10 )
	    {
		status |= overflow;
	    }

	    tmp *= 10UL;
	    tmp += digit;
	    status |= someDigits;
	}
	else
	{
	    ungetByte( byte );
	    break;
	}
    }
    while( getByte( byte ) != 0 );

    if( status != someDigits )
	return 0;

    value = tmp;

    return 1;
}
