/* 
 *  Licensed Materials - Property of IBM 
 *  Component IBM Rational ROSE_RT BUILD : TARGET_RTS 
 *  (c) Copyright IBM Corporation 1991, 2005 All Rights Reserved. 
 */

#include <RTDecoding.h>
#include <RTEncoding.h>
#include <RTObject_class.h>

static void unsignedchar_init( const RTObject_class *, void * target )
{
    *(unsigned char *)target = '\0';
}

static void unsignedchar_copy( const RTObject_class *,
			void                 * target,
			const void           * source )
{
    *(unsigned char *)target = *(const unsigned char *)source;
}

#if OBJECT_DECODE
static int unsignedchar_decode( const RTObject_class *,
			 void                 * target,
			 RTDecoding           * coding )
{
    return coding->get_unsignedchar( *(unsigned char *)target );
}
#endif

#if OBJECT_ENCODE
static int unsignedchar_encode( const RTObject_class *,
			 const void           * source,
			 RTEncoding           * coding )
{
    return coding->put_unsignedchar( *(const unsigned char *)source );
}
#endif

const RTObject_class RTType_unsignedchar =
{
    (RTObject_class *)0,
    (RTSuperAccessFunction)0,
    "unsigned char",
    (RTVersionId)0,
    (RTFieldOffset)sizeof( unsigned char ),
    unsignedchar_init,
    unsignedchar_copy,
#if OBJECT_DECODE
    unsignedchar_decode,
#endif
#if OBJECT_ENCODE
    unsignedchar_encode,
#endif
    RTnop_destroy,
    0, (const RTFieldDescriptor *)0
};

#if OBJECT_DECODE
RTTypeInstaller unsignedchar_installer( RTType_unsignedchar );
#endif
