/* 
 *  Licensed Materials - Property of IBM 
 *  Component IBM Rational ROSE_RT BUILD : TARGET_RTS 
 *  (c) Copyright IBM Corporation 1991, 2005 All Rights Reserved. 
 */

#include <RTDecoding.h>
#include <RTEncoding.h>
#include <RTObject_class.h>

static void unsignedint_init( const RTObject_class *, void * target )
{
    *(unsigned int *)target = 0;
}

static void unsignedint_copy( const RTObject_class *,
		      void                 * target,
		      const void           * source )
{
    *(unsigned int *)target = *(const unsigned int *)source;
}

#if OBJECT_DECODE
static int unsignedint_decode( const RTObject_class *,
		       void                 * target,
		       RTDecoding           * coding )
{
    return coding->get_unsignedint( *(unsigned int *)target );
}
#endif

#if OBJECT_ENCODE
static int unsignedint_encode( const RTObject_class *,
		       const void           * source,
		       RTEncoding           * coding )
{
    return coding->put_unsignedint( *(const unsigned int *)source );
}
#endif

const RTObject_class RTType_unsignedint =
{
    (RTObject_class *)0,
    (RTSuperAccessFunction)0,
    "unsigned int",
    (RTVersionId)0,
    (RTFieldOffset)sizeof( unsigned int ),
    unsignedint_init,
    unsignedint_copy,
#if OBJECT_DECODE
    unsignedint_decode,
#endif
#if OBJECT_ENCODE
    unsignedint_encode,
#endif
    RTnop_destroy,
    0, (const RTFieldDescriptor *)0
};

#if OBJECT_DECODE
RTTypeInstaller unsignedint_installer( RTType_unsignedint );
#endif
