/* 
 *  Licensed Materials - Property of IBM 
 *  Component IBM Rational ROSE_RT BUILD : TARGET_RTS 
 *  (c) Copyright IBM Corporation 1991, 2005 All Rights Reserved. 
 */

#include <RTDecoding.h>
#include <RTEncoding.h>
#include <RTObject_class.h>

static void unsignedlong_init( const RTObject_class *, void * target )
{
    *(unsigned long *)target = 0UL;
}

static void unsignedlong_copy( const RTObject_class *,
			void                 * target,
			const void           * source )
{
    *(unsigned long *)target = *(const unsigned long *)source;
}

#if OBJECT_DECODE
static int unsignedlong_decode( const RTObject_class *,
			 void                 * target,
			 RTDecoding           * coding )
{
    return coding->get_unsignedlong( *(unsigned long *)target );
}
#endif

#if OBJECT_ENCODE
static int unsignedlong_encode( const RTObject_class *,
			 const void           * source,
			 RTEncoding           * coding )
{
    return coding->put_unsignedlong( *(const unsigned long *)source );
}
#endif

const RTObject_class RTType_unsignedlong =
{
    (RTObject_class *)0,
    (RTSuperAccessFunction)0,
    "unsigned long",
    (RTVersionId)0,
    (RTFieldOffset)sizeof( unsigned long ),
    unsignedlong_init,
    unsignedlong_copy,
#if OBJECT_DECODE
    unsignedlong_decode,
#endif
#if OBJECT_ENCODE
    unsignedlong_encode,
#endif
    RTnop_destroy,
    0, (const RTFieldDescriptor *)0
};

#if OBJECT_DECODE
RTTypeInstaller unsignedlong_installer( RTType_unsignedlong );
#endif
