/* 
 *  Licensed Materials - Property of IBM 
 *  Component IBM Rational ROSE_RT BUILD : TARGET_RTS 
 *  (c) Copyright IBM Corporation 1991, 2005 All Rights Reserved. 
 */

#include <RTDecoding.h>
#include <RTEncoding.h>
#include <RTObject_class.h>

static void unsignedshort_init( const RTObject_class *, void * target )
{
    *(unsigned short *)target = 0U;
}

static void unsignedshort_copy( const RTObject_class *,
			 void                 * target,
			 const void           * source )
{
    *(unsigned short *)target = *(const unsigned short *)source;
}

#if OBJECT_DECODE
static int unsignedshort_decode( const RTObject_class *,
			  void                 * target,
			  RTDecoding           * coding )
{
    return coding->get_unsignedshort( *(unsigned short *)target );
}
#endif

#if OBJECT_ENCODE
static int unsignedshort_encode( const RTObject_class *,
			  const void           * source,
			  RTEncoding           * coding )
{
    return coding->put_unsignedshort( *(const unsigned short *)source );
}
#endif

const RTObject_class RTType_unsignedshort =
{
    (RTObject_class *)0,
    (RTSuperAccessFunction)0,
    "unsigned short",
    (RTVersionId)0,
    (RTFieldOffset)sizeof( unsigned short ),
    unsignedshort_init,
    unsignedshort_copy,
#if OBJECT_DECODE
    unsignedshort_decode,
#endif
#if OBJECT_ENCODE
    unsignedshort_encode,
#endif
    RTnop_destroy,
    0, (const RTFieldDescriptor *)0
};

#if OBJECT_DECODE
RTTypeInstaller unsignedshort_installer( RTType_unsignedshort );
#endif
