#! perl -w

# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 1991, 2005 All Rights Reserved. 

# Script:  terminate.pl
#
# Summary: This script is used to kill a specified process.
#          It creates the kill process and passes it the pid parameter.
#
# History:
#          1998/09   Creation.

$rt_pid = undef;

while( $_ = shift @ARGV )
{
	$rt_pid = shift @ARGV if m/^-pid$/;
}

defined $rt_pid
	or die "Failed: Missing PID parameter\n";

kill 0, $rt_pid
	or die "Failed: Process $rt_pid not found\n";

kill 15, $rt_pid;

print "::Ok::\n";

exit 0;
